#include <stdlib.h>
#include <string.h>

#include <EXTERN.h>
#include <perl.h>

#include "perlwow.h"

#include <powwow/defines.h>
#include <powwow/cmd.h>

/* generated by perl -MExtUtils::Embed -e xsinit -- -o perlxsi.h */
#include "embperlxsi.h"

/* this will be created by the xsubpp program from powwow.xs in powwow-xs.c */
EXTERN_C void boot_powwow (pTHXo_ CV* cv);

/* Our static function list */
cmdstruct mycommand = { NULL, "perl", "Execute a perl function", perlwow_exec, NULL };

void powwow_init() {
	// register #perl and call init
        printf( "perlwow plugin v" VERSION " for powwow\n"
		"Author: Steve Slaven - http://hoopajoo.net\n" );

	cmd_add_command( &mycommand );
	/* init perl */
	perlwow_init();
}

void perlwow_init() {
	char *embedding[] = { "", "-e", "0" };
	char file[] = __FILE__;

	perlwow = perl_alloc();
	perl_construct( perlwow );
	perl_parse( perlwow, xs_init, 3, embedding, NULL );

	/* initialize powwow extension */
	newXS( "powwow::boot_powwow", boot_powwow, file );
	eval_pv( "powwow::boot_powwow", TRUE );

	/* Try an make it so exit will not kill us :( */
	eval_pv( "use subs qw( exit )", TRUE );
	eval_pv( "sub exit { die( 'Warning... Tried to exit!' ) }", TRUE );
}

void perlwow_destroy() {
	perl_destruct( perlwow );
	perl_free( perlwow );
}

/* execute perl code, always in an eval block to catch fatal errors */
void perlwow_exec( const char *arg ) {
	char *eval = malloc( strlen( arg ) + 60 );

	sprintf( eval, "eval { %s }; warn $@ if $@", arg );
	//printf( "Executing: '%s'\n", eval );
	eval_pv( eval, TRUE );
	free( eval );

	/* print error if problems */
	//eval_pv( "warn $@ if $@", TRUE );
}
